## fftw 1.0-1

=== DESCRIPTION ===
Package: fftw
Version: 1.0-1
Title: Fast FFT and DCT based on FFTW
Description: Provides a simple and efficient wrapper around the fastest
        Fourier transform in the west (FFTW) library.
Author: Sebastian Krey <skrey@statistik.tu-dortmund.de> Uwe Ligges
        <ligges@statistik.tu-dortmund.de> Olaf Mersmann
        <olafm@statistik.tu-dortmund.de>
Maintainer: Olaf Mersmann <olafm@statistik.tu-dortmund.de>
Depends: R (>= 2.10.0)
SystemRequirements: fftw3 (>= 3.1.2)
License: GPL-2
Date:
Packaged: 2010-01-28 17:39:38 UTC; olafm
Repository: CRAN
Date/Publication: 2010-01-29 07:52:53

## fftw 1.0-2

=== DESCRIPTION ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Package: fftw
-Version: 1.0-1
+Version: 1.0-2
 Title: Fast FFT and DCT based on FFTW
 Description: Provides a simple and efficient wrapper around the fastest
         Fourier transform in the west (FFTW) library.
@@ -11,6 +11,6 @@
 SystemRequirements: fftw3 (>= 3.1.2)
 License: GPL-2
 Date:
-Packaged: 2010-01-28 17:39:38 UTC; olafm
+Packaged: 2010-04-05 16:12:32 UTC; olafm
 Repository: CRAN
-Date/Publication: 2010-01-29 07:52:53
+Date/Publication: 2010-04-05 16:14:29

## fftw 1.0-3

=== DESCRIPTION ===
Package: fftw
Version: 1.0-3
Title: Fast FFT and DCT based on FFTW
Description: Provides a simple and efficient wrapper around the fastest
        Fourier transform in the west (FFTW) library.
Author: Sebastian Krey <skrey@statistik.tu-dortmund.de> Uwe Ligges
        <ligges@statistik.tu-dortmund.de> Olaf Mersmann
        <olafm@statistik.tu-dortmund.de>
Maintainer: Olaf Mersmann <olafm@statistik.tu-dortmund.de>
Depends: R (>= 2.12.0)
SystemRequirements: fftw3 (>= 3.1.2)
License: GPL-2
Date:
Packaged: 2011-04-20 08:49:10 UTC; olafm
Repository: CRAN
Date/Publication: 2011-04-24 07:08:12

## fftw 1.0-4

=== DESCRIPTION ===
Package: fftw
Version: 1.0-4
Title: Fast FFT and DCT Based on the FFTW Library
Description: Provides a simple and efficient wrapper around the fastest
        Fourier transform in the west (FFTW) <http://www.fftw.org/> library.
Authors@R: c( person("Olaf", "Mersmann", email="olafm@p-value.net",
        role=c("aut")), person("Sebastian", "Krey",
        email="skrey@statistik.tu-dortmund.de", role=c("ctb")),
        person("Uwe", "Ligges",
        email="ligges@statistik.tu-dortmund.de", role=c("ctb", "cre")) )
Depends: R (>= 3.0.0)
SystemRequirements: fftw3 (>= 3.1.2)
License: GPL-2
RoxygenNote: 6.0.1
NeedsCompilation: yes
Packaged: 2017-05-01 16:32:33 UTC; ligges
Author: Olaf Mersmann [aut],
  Sebastian Krey [ctb],
  Uwe Ligges [ctb, cre]
Maintainer: Uwe Ligges <ligges@statistik.tu-dortmund.de>
Repository: CRAN
Date/Publication: 2017-05-01 19:19:56 UTC

## fftw 1.0-5

=== DESCRIPTION ===
Package: fftw
Version: 1.0-5
Title: Fast FFT and DCT Based on the FFTW Library
Description: Provides a simple and efficient wrapper around the fastest
        Fourier transform in the west (FFTW) library <http://www.fftw.org/>.
Authors@R: c( person("Olaf", "Mersmann", email="olafm@p-value.net",
        role=c("aut")), person("Sebastian", "Krey",
        email="skrey@statistik.tu-dortmund.de", role=c("ctb")),
        person("Uwe", "Ligges",
        email="ligges@statistik.tu-dortmund.de", role=c("ctb", "cre")) )
Depends: R (>= 3.0.0)
SystemRequirements: fftw3 (>= 3.1.2)
License: GPL-2
RoxygenNote: 6.0.1
NeedsCompilation: yes
Packaged: 2019-03-04 12:47:53 UTC; ligges
Author: Olaf Mersmann [aut],
  Sebastian Krey [ctb],
  Uwe Ligges [ctb, cre]
Maintainer: Uwe Ligges <ligges@statistik.tu-dortmund.de>
Repository: CRAN
Date/Publication: 2019-03-04 13:50:09 UTC

## fftw 1.2.1

=== cilk/Makefile ===
FFTWDIR = ../src
FFTW_INCLUDE = -I$(FFTWDIR)
OTHER_FFTW_OBJECTS = malloc.o twiddle.o planner.o config.o
FFTW_LIB_NON_CILK = $(FFTWDIR)/f*.o $(FFTWDIR)/generic.o \
                    $(FFTWDIR)/timer.o $(FFTWDIR)/executor.o \
                    $(FFTWDIR)/wisdom.o $(FFTWDIR)/common_io.o

FFTW_LIB = $(FFTW_LIB_NON_CILK) $(OTHER_FFTW_OBJECTS)

ALL_FFTW_CILK_OBJ = $(OTHER_FFTW_OBJECTS) executor_cilk.o fftwnd_cilk.o  \
                    $(FFTW_LIB_NON_CILK)

LIBFFTW_CILK = libfftw_cilk.a

# Set where you want to install the library for "make install"
prefix = /usr/local
LIBDIR = $(prefix)/lib
INCLUDEDIR = $(prefix)/include

# On systems that have ranlib:
RANLIB = ranlib

# On systems that don't have ranlib
# RANLIB = echo ranlib

all:	$(LIBFFTW_CILK)

tests: test_cilk time_cilk

nd:     test_cilk.nd

ndl:    test_cilk.ndl

RM = rm

clean:	
	$(RM) *.o core malloc.cilk planner.cilk executor.cilk config.cilk \
              twiddle.cilk test_cilk time_cilk test_cilk.nd test_cilk.ndl \
              a.out *~ *.s *.bak 

realclean: clean
	$(RM) $(LIBFFTW_CILK)

####################### Cilk Libraries, etc. ####################

# set this to point to the Cilk distribution directory.
CILK_DIR = /usr/local/6.892/cilk

# include makefile from distribution directory
include $(CILK_DIR)/Makefile.common

# set this to a version of gcc that uses the GNU linker:
CC = /usr/local/cilk/bin/gcc

# Set this to 1/2/3 to enable critical path measurements (slow)
CILK_CRITICAL_PATH=0

LIBS    = -lm $(CILK_RTS) $(CILK_LIB) $(ARCHLIBS)
HEADERS = $(CILK_HEADERS) $(FFTWDIR)/fftw.h fftw_cilk.cilkh
MY_CFLAGS = $(FFTW_INCLUDE) $(CFLAGS) -O6 -DFFTW_USING_CILK

###################### Building fftw_cilk #######################

AR = ar

config.cilk: $(FFTWDIR)/config.c
	cp $(FFTWDIR)/config.c config.cilk

malloc.cilk: $(FFTWDIR)/malloc.c
	cp $(FFTWDIR)/malloc.c malloc.cilk

twiddle.cilk: $(FFTWDIR)/twiddle.c
	cp $(FFTWDIR)/twiddle.c twiddle.cilk

planner.cilk: $(FFTWDIR)/planner.c
	cp $(FFTWDIR)/planner.c planner.cilk

%.o:	%.c $(HEADERS)
	$(CC) $(MY_CFLAGS) -c $< -o $@

%.c:	%.cilk $(HEADERS) $(CILK2C)
	$(CILK2C) $(CILK2CFLAGS) -- $(MY_CFLAGS) -- $< -o $@ 

$(LIBFFTW_CILK): executor_cilk.o fftwnd_cilk.o $(OTHER_FFTW_OBJECTS)
	$(RM) -f $(LIBFFTW_CILK)
	$(AR) rv $(LIBFFTW_CILK) $(ALL_FFTW_CILK_OBJ)
	$(RANLIB) $(LIBFFTW_CILK)

install: $(LIBFFTW_CILK)
	$(CP) $(LIBFFTW_CILK) $(LIBDIR)
	$(RANLIB) $(LIBDIR)/$(LIBFFTW_CILK)
	$(CP) fftw_cilk.cilkh $(INCLUDEDIR)

test_cilk: test_cilk.o $(LIBFFTW_CILK) $(CILK_RTS) $(CILK_LIB)
	$(CC) $(LDFLAGS) test_cilk.o \
              $(LIBS) $(LIBFFTW_CILK) -o test_cilk

time_cilk: time_cilk.o $(LIBFFTW_CILK) $(CILK_RTS) $(CILK_LIB)
	$(CC) $(LDFLAGS) time_cilk.o \
              $(LIBS) $(LIBFFTW_CILK) -o time_cilk

################### Using the Nondeterminator ###################

ND_DIR = $(CILK_DIR)/nd
CILK2CFLAGS_ND = $(CILK2CFLAGS) -nd
CFLAGS_ND  = -I$(ND_DIR) $(MY_CFLAGS)
NDFLAGS =

CILK_RTS_ND = $(ND_DIR)/cilk-rts.nd.a
CILK_RTS_NDL = $(ND_DIR)/cilk-rts.ndl.a
LIBS_ND = -lm $(CILK_RTS_ND) $(CILK_LIB) $(ARCHLIBS)
LIBS_NDL = -lm $(CILK_RTS_NDL) $(CILK_LIB) $(ARCHLIBS)
HEADERS_ND = $(CILK_HEADERS) $(ND_DIR)/cilk-nd.h $(ND_DIR)/cilk-nd-cilk2c.h

# building normal version with the Nondeterminator
test_cilk.nd:   test_cilk.nd.o executor_cilk.nd.o fftwnd_cilk.nd.o \
                $(OTHER_FFTW_OBJECTS) $(CILK_RTS_ND) $(CILK_LIB)
	$(CC) $(LDFLAGS) test_cilk.nd.o executor_cilk.nd.o fftwnd_cilk.nd.o \
              $(LIBS_ND) $(FFTW_LIB) -o $@

%.nd.o: %.nd.c $(HEADERS_ND)
	$(CC) $(CFLAGS_ND) $(NDFLAGS) -DCILK_ND -c $< -o $@

%.nd.c: %.cilk $(HEADERS_ND) $(CILK2C)
	$(CILK2C) $(CILK2CFLAGS_ND) -- $(CFLAGS_ND) $(NDFLAGS)  \
                  -DCILK_ND -- $< -o $@

# building luxurious version with the Nondeterminator
test_cilk.ndl:  test_cilk.ndl.o executor_cilk.ndl.o fftwnd_cilk.ndl.o \
                $(OTHER_FFTW_OBJECTS) $(CILK_RTS_NDL) $(CILK_LIB)
	$(CC) $(LDFLAGS) test_cilk.ndl.o executor_cilk.ndl.o fftwnd_cilk.ndl.o\
              $(LIBS_NDL) $(FFTW_LIB) -o $@

%.ndl.o:        %.ndl.c $(HEADERS_ND)
	$(CC) $(CFLAGS_ND) $(NDFLAGS) -DCILK_NDL -c $< -o $@

%.ndl.c:        %.cilk $(HEADERS_ND)
	$(CILK2C) $(CILK2CFLAGS_ND) -- $(CFLAGS_ND) $(NDFLAGS) \
                  -DCILK_NDL -- $< -o $@

=== doc/Makefile ===
# $Id: Makefile,v 1.9 1997/03/19 23:27:04 fftw Exp $

DOC = fftw
WWWDOC=$(HOME)/WWW/doc

all:	html info dvi ps

html:	$(DOC).texi
	perl texi2html -split_chapter -no_toc_href $(DOC).texi

info:	$(DOC).texi
	makeinfo $(DOC).texi

dvi:	$(DOC).texi
	tex $(DOC).texi
	tex $(DOC).texi

ps:	dvi
	dvips -o $(DOC).ps $(DOC).dvi

install-html: html
	cp *.html *.gif $(WWWDOC)

realclean: clean
	rm -f *.html *.info *.dvi *.ps

clean:  
	rm -f *.aux *.cp *.fn *.ky *.log *.pg *~ *.toc *.tp *.vr

=== mpi/Makefile ===
TRANSPOSE_DIR = transpose_mpi
TRANSPOSE_LIB = $(TRANSPOSE_DIR)/transpose_mpi.o \
                $(TRANSPOSE_DIR)/TOMS_transpose.o

FFTW_DIR = ../src
FFTW_LIB = $(FFTW_DIR)/libfftw.a

INC = -I$(TRANSPOSE_DIR) -I. -I$(FFTW_DIR)

# Solaris:
CC = mpicc
CFLAGS = -native -fast -xO5 -dalign -DSOLARIS $(INC)

all: test_fftwnd_mpi time_fftwnd_mpi

test_fftwnd_mpi: test_fftwnd_mpi.o fftwnd_mpi.o $(TRANSPOSE_LIB) \
			$(FFTW_LIB)
	$(CC) $(CFLAGS) test_fftwnd_mpi.o fftwnd_mpi.o $(TRANSPOSE_LIB) \
		$(FFTW_LIB) -lm -o test_fftwnd_mpi

time_fftwnd_mpi: time_fftwnd_mpi.o fftwnd_mpi.o $(TRANSPOSE_LIB) \
			$(FFTW_LIB)
	$(CC) $(CFLAGS) time_fftwnd_mpi.o fftwnd_mpi.o $(TRANSPOSE_LIB) \
		$(FFTW_LIB) -lm -o time_fftwnd_mpi

clean:
	rm -f *.o core a.out test_fftwnd_mpi time_fftwnd_mpi *~

=== rfftw/Makefile ===
# $Id: Makefile,v 1.3 1997/08/26 21:21:00 fftw Exp $

FFTWDIR=../src
LIBFFT = $(FFTWDIR)/libfftw.a
HEADERS = $(FFTWDIR)/fftw.h
INCLUDE = -I$(FFTWDIR)

# The default, gcc:
CC = gcc
CFLAGS = -O6 -Wall $(INCLUDE)

# Solaris compiler options:
# CC = cc
# CFLAGS = -DSOLARIS -fast -xO5 -native -dalign $(INCLUDE)

all:	test_rfftw time_rfftw

test_rfftw:	test_rfftw.c rfftw.o rfftwnd.o
	$(CC) $(CFLAGS) -o test_rfftw test_rfftw.c \
		rfftwnd.o rfftw.o $(LIBFFT) -lm

time_rfftw:	time_rfftw.c rfftw.o
	$(CC) $(CFLAGS) -o time_rfftw time_rfftw.c \
		rfftwnd.o rfftw.o $(LIBFFT) -lm

clean:
	rm -f *.o *~ core a.out test_rfftw time_rfftw gmon.out mon.out *.s

=== src/Makefile ===
# $Id: Makefile,v 1.30 1997/08/20 19:00:13 fftw Exp $

LIBFFT = libfftw.a
HEADERS = fftw.h
INCLUDE = -I.
prefix = /usr/local
LIBDIR = $(prefix)/lib
INCLUDEDIR = $(prefix)/include
RM = rm
CP = cp
MAKE = make

# On systems that have ranlib:
RANLIB = ranlib

# On systems that don't have ranlib
# RANLIB = echo ranlib

# Generic gcc
CC = gcc
CFLAGS = -pedantic -ansi -O6 -fomit-frame-pointer -Wall $(INCLUDE)

# Solaris:
# CC = cc
# CFLAGS = -DSOLARIS -native -fast -xO5 -dalign $(INCLUDE)

# IBM RS/6000:
# CC=cc
# CFLAGS = -O3 -qarch=pwrx -qtune=pwrx $(INCLUDE)

# SGI Onyx
# CC=cc
# CFLAGS=-64 -r10000 -OPT:fold_arith_limit=10000 -O3 $(INCLUDE)

# Filename prefixes:

#NOTW_PREFIX=fftw_notw_
#TWID_PREFIX=fftw_twid_
#NOTWI_PREFIX=fftwi_notw_
#TWIDI_PREFIX=fftwi_twid_

# # Or, on primitive systems with 8.3 filenames:
NOTW_PREFIX=fn_
TWID_PREFIX=ftw_
NOTWI_PREFIX=fni_
TWIDI_PREFIX=ftwi_

NOTW_BLOCKS=$(NOTW_PREFIX)1.o $(NOTW_PREFIX)2.o $(NOTW_PREFIX)3.o     \
	$(NOTW_PREFIX)4.o $(NOTW_PREFIX)5.o $(NOTW_PREFIX)6.o         \
	$(NOTW_PREFIX)7.o $(NOTW_PREFIX)8.o $(NOTW_PREFIX)9.o         \
	$(NOTW_PREFIX)10.o $(NOTW_PREFIX)11.o $(NOTW_PREFIX)12.o      \
	$(NOTW_PREFIX)13.o $(NOTW_PREFIX)14.o $(NOTW_PREFIX)15.o      \
	$(NOTW_PREFIX)16.o $(NOTW_PREFIX)32.o $(NOTW_PREFIX)64.o      

TWID_BLOCKS=$(TWID_PREFIX)2.o $(TWID_PREFIX)3.o $(TWID_PREFIX)4.o     \
	$(TWID_PREFIX)5.o $(TWID_PREFIX)6.o $(TWID_PREFIX)7.o         \
	$(TWID_PREFIX)8.o $(TWID_PREFIX)9.o $(TWID_PREFIX)10.o        \
	$(TWID_PREFIX)16.o $(TWID_PREFIX)32.o $(TWID_PREFIX)64.o

NOTWI_BLOCKS=$(NOTWI_PREFIX)1.o $(NOTWI_PREFIX)2.o $(NOTWI_PREFIX)3.o \
	$(NOTWI_PREFIX)4.o $(NOTWI_PREFIX)5.o $(NOTWI_PREFIX)6.o      \
	$(NOTWI_PREFIX)7.o $(NOTWI_PREFIX)8.o $(NOTWI_PREFIX)9.o      \
	$(NOTWI_PREFIX)10.o $(NOTWI_PREFIX)11.o $(NOTWI_PREFIX)12.o   \
	$(NOTWI_PREFIX)13.o $(NOTWI_PREFIX)14.o $(NOTWI_PREFIX)15.o   \
	$(NOTWI_PREFIX)16.o $(NOTWI_PREFIX)32.o $(NOTWI_PREFIX)64.o

TWIDI_BLOCKS=$(TWIDI_PREFIX)2.o $(TWIDI_PREFIX)3.o                   \
	$(TWIDI_PREFIX)4.o $(TWIDI_PREFIX)5.o $(TWIDI_PREFIX)6.o    \
	$(TWIDI_PREFIX)7.o $(TWIDI_PREFIX)8.o $(TWIDI_PREFIX)9.o    \
	$(TWIDI_PREFIX)10.o $(TWIDI_PREFIX)16.o $(TWIDI_PREFIX)32.o \
        $(TWIDI_PREFIX)64.o

NOTW_SRC=$(NOTW_PREFIX)1.c $(NOTW_PREFIX)2.c $(NOTW_PREFIX)3.c        \
	$(NOTW_PREFIX)4.c $(NOTW_PREFIX)5.c $(NOTW_PREFIX)6.c         \
	$(NOTW_PREFIX)7.c $(NOTW_PREFIX)8.c $(NOTW_PREFIX)9.c         \
	$(NOTW_PREFIX)10.c $(NOTW_PREFIX)11.c $(NOTW_PREFIX)12.c      \
	$(NOTW_PREFIX)13.c $(NOTW_PREFIX)14.c $(NOTW_PREFIX)15.c      \
	$(NOTW_PREFIX)16.c $(NOTW_PREFIX)32.c $(NOTW_PREFIX)64.c

TWID_SRC=$(TWID_PREFIX)2.c $(TWID_PREFIX)3.c $(TWID_PREFIX)4.c        \
	$(TWID_PREFIX)5.c $(TWID_PREFIX)6.c $(TWID_PREFIX)7.c         \
	$(TWID_PREFIX)8.c $(TWID_PREFIX)9.c $(TWID_PREFIX)10.c        \
	$(TWID_PREFIX)16.c $(TWID_PREFIX)32.c $(TWID_PREFIX)64.c

NOTWI_SRC=$(NOTWI_PREFIX)1.c $(NOTWI_PREFIX)2.c $(NOTWI_PREFIX)3.c    \
	$(NOTWI_PREFIX)4.c $(NOTWI_PREFIX)5.c $(NOTWI_PREFIX)6.c      \
	$(NOTWI_PREFIX)7.c $(NOTWI_PREFIX)8.c $(NOTWI_PREFIX)9.c      \
	$(NOTWI_PREFIX)10.c $(NOTWI_PREFIX)11.c $(NOTWI_PREFIX)12.c   \
	$(NOTWI_PREFIX)13.c $(NOTWI_PREFIX)14.c $(NOTWI_PREFIX)15.c   \
	$(NOTWI_PREFIX)16.c $(NOTWI_PREFIX)32.c $(NOTWI_PREFIX)64.c

TWIDI_SRC=$(TWIDI_PREFIX)2.c $(TWIDI_PREFIX)3.c $(TWIDI_PREFIX)4.c  \
	$(TWIDI_PREFIX)5.c $(TWIDI_PREFIX)6.c $(TWIDI_PREFIX)7.c    \
	$(TWIDI_PREFIX)8.c $(TWIDI_PREFIX)9.c $(TWIDI_PREFIX)10.c   \
	$(TWIDI_PREFIX)16.c $(TWIDI_PREFIX)32.c $(TWIDI_PREFIX)64.c

OTHEROBJ = timer.o config.o planner.o twiddle.o executor.o naive.o \
	generic.o fftwnd.o malloc.o wisdom.o common_io.o

BLOCKS = $(NOTW_BLOCKS) $(NOTWI_BLOCKS) $(TWID_BLOCKS) $(TWIDI_BLOCKS) 

ALLOBJ = $(BLOCKS) $(OTHEROBJ)


all:	$(LIBFFT) 

install: $(LIBFFT)
	$(CP) $(LIBFFT) $(LIBDIR)
	$(RANLIB) $(LIBDIR)/$(LIBFFT)
	$(CP) $(HEADERS) $(INCLUDEDIR)

$(LIBFFT): $(ALLOBJ)
	$(RM) -f $(LIBFFT)
	$(AR) rv $(LIBFFT) $(ALLOBJ)
	$(RANLIB) $(LIBFFT)

sources: 
	$(MAKE) -f Makefile.sources $(NOTW_SRC) $(NOTWI_SRC) \
	     $(TWID_SRC) $(TWIDI_SRC) \
	     NOTW_PREFIX=$(NOTW_PREFIX)     \
	     NOTWI_PREFIX=$(NOTWI_PREFIX)   \
	     TWID_PREFIX=$(TWID_PREFIX)     \
	     TWIDI_PREFIX=$(TWIDI_PREFIX)

realclean: clean
	$(RM) -f $(LIBFFT)  $(NOTW_SRC) $(NOTWI_SRC) $(TWID_SRC) $(TWIDI_SRC)

clean:
	$(RM) -f *.o *~ core a.out test gmon.out mon.out *.zi *.zo *.s genfft

$(ALLOBJ): $(HEADERS) konst.h

=== tests/Makefile ===
# $Id: Makefile,v 1.10 1997/07/07 15:25:07 fftw Exp $

FFTWDIR=../src
LIBFFT = $(FFTWDIR)/libfftw.a
HEADERS = $(FFTWDIR)/fftw.h
INCLUDE = -I$(FFTWDIR)

# Generic gcc
CC = gcc
CFLAGS = -O6 -fomit-frame-pointer -Wall $(INCLUDE)

# WARNING: Solaris' compiler apparently produces wrong code
# for go_fft.c when -xO5 is enabled.  Please stick with -xO2

# Solaris:
# CC = cc
# CFLAGS = -DSOLARIS -native -fast -xO2 -dalign $(INCLUDE)

# IBM RS/6000:
# CC=cc
# CFLAGS = -O3 -qarch=pwrx -qtune=pwrx $(INCLUDE)

# SGI Onyx
# CC=cc
# CFLAGS=-64 -r10000 -O3 $(INCLUDE)

all:	fftw_test testnd

fftw_test:	fftw_test.c $(LIBFFT)
	$(CC) $(CFLAGS) -o fftw_test fftw_test.c $(LIBFFT) -lm

testnd:	testnd.c go_fft.c $(LIBFFT)
	$(CC) $(CFLAGS) -o testnd testnd.c go_fft.c $(LIBFFT) -lm

clean:
	rm -f *.o *~ core a.out test testnd gmon.out mon.out *.s

=== threads/Makefile ===
FFTWDIR = ../src
FFTW_INCLUDE = -I$(FFTWDIR)
FFTW_LIB = $(FFTWDIR)/libfftw.a

LIBFFTW_THREADS = libfftw_threads.a

# Set where you want to install the library for "make install"
prefix = /usr/local
LIBDIR = $(prefix)/lib
INCLUDEDIR = $(prefix)/include

##### Set the thread library that is used #####

# POSIX threads:
FFTW_THREADS = FFTW_USING_POSIX_THREADS  # the default
FFTW_THREADLIB = -lpthread

# Solaris threads:
# FFTW_THREADS = FFTW_USING_SOLARIS_THREADS
# FFTW_THREADLIB = -lthread

# BeOS threads: (tested for DR8.2)
# FFTW_THREADS = FFTW_USING_BEOS_THREADS
# FFTW_THREADLIB =   # ...add any libraries here that need to be linked in

##### Defining the compilers used, etc.   #####

# On systems that have ranlib:
RANLIB = ranlib

# On systems that don't have ranlib
# RANLIB = echo ranlib

RM = rm

# Generic gcc
CC = gcc
CFLAGS = -pedantic -ansi -O6 -fomit-frame-pointer -Wall $(INCLUDE) \
         -D$(FFTW_THREADS) -D_POSIX_C_SOURCE

# Solaris:
# CC = cc
# CFLAGS = -DSOLARIS -native -fast -xO5 -dalign $(INCLUDE) -D$(FFTW_THREADS)

# IBM RS/6000:
# CC=cc
# CFLAGS = -O3 -qarch=pwrx -qtune=pwrx $(INCLUDE) -D$(FFTW_THREADS)

# SGI Onyx
# CC=cc
# CFLAGS=-64 -r10000 -OPT:fold_arith_limit=10000 -O3 $(INCLUDE) -D$(FFTW_THREADS)


###################### Building fftw_threads #######################

INCLUDE = $(FFTW_INCLUDE) -I.
HEADERS = $(FFTWDIR)/fftw.h fftw_threads.h
LIBS = $(FFTW_LIB) $(FFTW_THREADLIB) -lm

LIBFFTW_THREADS_OBJ = executor_threads.o fftwnd_threads.o fftw_threads.o

all:	$(LIBFFTW_THREADS)

tests: test_threads time_threads

clean:	
	$(RM) -f *.o core a.out *~ *.s *.bak

realclean: clean
	$(RM) -f $(LIBFFTW_THREADS) test_threads time_threads

%.o:	%.c $(HEADERS)
	$(CC) $(CFLAGS) -c $< -o $@

$(LIBFFTW_THREADS): $(LIBFFTW_THREADS_OBJ)
	$(RM) -f $(LIBFFTW_THREADS)
	$(AR) rv $(LIBFFTW_THREADS) $(LIBFFTW_THREADS_OBJ)
	$(RANLIB) $(LIBFFTW_THREADS)

install: $(LIBFFTW_THREADS)
	$(CP) $(LIBFFTW_THREADS) $(LIBDIR)
	$(RANLIB) $(LIBDIR)/$(LIBFFTW_THREADS)
	$(CP) fftw_threads.h $(INCLUDEDIR)

test_threads: test_threads.o $(LIBFFTW_THREADS)
	$(CC) $(LDFLAGS) test_threads.o \
              $(LIBS) $(LIBFFTW_THREADS) -o test_threads

time_threads: time_threads.o $(LIBFFTW_THREADS)
	$(CC) $(LDFLAGS) time_threads.o \
              $(LIBS) $(LIBFFTW_THREADS) -o time_threads

## fftw 2.0.1

=== FAQ/Makefile ===
all:
	@echo converting 1 ...
	perl bfnnconv.pl fftw-faq.bfnn
	@echo converting 2 ...
	perl bfnnconv.pl fftw-faq.bfnn

install-html: all
	cp fftw-faq.html/* $(HOME)/WWW/faq/

clean:
	rm -f *~ core a.out *.lout *.ps *.info *.ascii *.xrefdb *.post
	rm -rf *.html

=== cilk/Makefile ===
--- 
+++ 
@@ -1,9 +1,9 @@
-FFTWDIR = ../src
+FFTWDIR = ../fftw
 FFTW_INCLUDE = -I$(FFTWDIR)
-OTHER_FFTW_OBJECTS = malloc.o twiddle.o planner.o config.o
+OTHER_FFTW_OBJECTS = malloc.o twiddle.o planner.o config.o putils.o rader.o
 FFTW_LIB_NON_CILK = $(FFTWDIR)/f*.o $(FFTWDIR)/generic.o \
                     $(FFTWDIR)/timer.o $(FFTWDIR)/executor.o \
-                    $(FFTWDIR)/wisdom.o $(FFTWDIR)/common_io.o
+                    $(FFTWDIR)/wisdom.o $(FFTWDIR)/wisdomio.o 
 
 FFTW_LIB = $(FFTW_LIB_NON_CILK) $(OTHER_FFTW_OBJECTS)
 
@@ -27,30 +27,27 @@
 
 tests: test_cilk time_cilk
 
-nd:     test_cilk.nd
-
-ndl:    test_cilk.ndl
-
 RM = rm
 
 clean:	
-	$(RM) *.o core malloc.cilk planner.cilk executor.cilk config.cilk \
+	$(RM) -f *.o core malloc.cilk planner.cilk executor.cilk config.cilk \
               twiddle.cilk test_cilk time_cilk test_cilk.nd test_cilk.ndl \
+	      putils.cilk rader.cilk \
               a.out *~ *.s *.bak 
 
-realclean: clean
-	$(RM) $(LIBFFTW_CILK)
+distclean: clean
+	$(RM) -f $(LIBFFTW_CILK) test_cilk time_cilk *.out
 
 ####################### Cilk Libraries, etc. ####################
 
 # set this to point to the Cilk distribution directory.
-CILK_DIR = /usr/local/6.892/cilk
+CILK_DIR = $(HOME)/sandbox/cilk
 
 # include makefile from distribution directory
 include $(CILK_DIR)/Makefile.common
 
 # set this to a version of gcc that uses the GNU linker:
-CC = /usr/local/cilk/bin/gcc
+CC = gcc
 
 # Set this to 1/2/3 to enable critical path measurements (slow)
 CILK_CRITICAL_PATH=0
@@ -64,7 +61,8 @@
 AR = ar
 
 config.cilk: $(FFTWDIR)/config.c
-	cp $(FFTWDIR)/config.c config.cilk
+	(echo "#include <cilk.h>"; \
+	cat $(FFTWDIR)/config.c) >config.cilk
 
 malloc.cilk: $(FFTWDIR)/malloc.c
 	cp $(FFTWDIR)/malloc.c malloc.cilk
@@ -75,11 +73,21 @@
 planner.cilk: $(FFTWDIR)/planner.c
 	cp $(FFTWDIR)/planner.c planner.cilk
 
-%.o:	%.c $(HEADERS)
+putils.cilk: $(FFTWDIR)/putils.c
+	cp $(FFTWDIR)/putils.c putils.cilk
+
+rader.cilk: $(FFTWDIR)/rader.c
+	cp $(FFTWDIR)/rader.c rader.cilk
+
+
+%.o:	%.c $(HEADERS) $(CILK_DIR)/Makefile.common Makefile
 	$(CC) $(MY_CFLAGS) -c $< -o $@
 
-%.c:	%.cilk $(HEADERS) $(CILK2C)
-	$(CILK2C) $(CILK2CFLAGS) -- $(MY_CFLAGS) -- $< -o $@ 
+%.s:	%.c $(HEADERS) $(CILK_DIR)/Makefile.common Makefile
+	$(CC) $(MY_CFLAGS) -S $< -o $@
+
+%.c:	%.cilk $(HEADERS) $(CILK2C) $(CILK_DIR)/Makefile.common Makefile
+	$(CILK2C) $(CILK2CFLAGS) -- $(MY_CFLAGS) -- $< -o $@
 
 $(LIBFFTW_CILK): executor_cilk.o fftwnd_cilk.o $(OTHER_FFTW_OBJECTS)
 	$(RM) -f $(LIBFFTW_CILK)

=== mpi/Makefile ===
--- 
+++ 
@@ -2,8 +2,8 @@
 TRANSPOSE_LIB = $(TRANSPOSE_DIR)/transpose_mpi.o \
                 $(TRANSPOSE_DIR)/TOMS_transpose.o
 
-FFTW_DIR = ../src
-FFTW_LIB = $(FFTW_DIR)/libfftw.a
+FFTW_DIR = ../fftw
+FFTW_LIB = $(FFTW_DIR)/.libs/libfftw.a
 
 INC = -I$(TRANSPOSE_DIR) -I. -I$(FFTW_DIR)
 
@@ -23,5 +23,7 @@
 	$(CC) $(CFLAGS) time_fftwnd_mpi.o fftwnd_mpi.o $(TRANSPOSE_LIB) \
 		$(FFTW_LIB) -lm -o time_fftwnd_mpi
 
+distclean: clean
+
 clean:
 	rm -f *.o core a.out test_fftwnd_mpi time_fftwnd_mpi *~

=== threads/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
-FFTWDIR = ../src
+FFTWDIR = ../fftw
 FFTW_INCLUDE = -I$(FFTWDIR)
-FFTW_LIB = $(FFTWDIR)/libfftw.a
+FFTW_LIB = $(FFTWDIR)/.libs/libfftw.a
 
 LIBFFTW_THREADS = libfftw_threads.a
 
@@ -21,6 +21,10 @@
 
 # BeOS threads: (tested for DR8.2)
 # FFTW_THREADS = FFTW_USING_BEOS_THREADS
+# FFTW_THREADLIB =   # ...add any libraries here that need to be linked in
+
+# Win32 threads: (reported by users as working in NT with MS compilers)
+# FFTW_THREADS = FFTW_USING_WIN32_THREADS
 # FFTW_THREADLIB =   # ...add any libraries here that need to be linked in
 
 ##### Defining the compilers used, etc.   #####
@@ -59,15 +63,15 @@
 
 LIBFFTW_THREADS_OBJ = executor_threads.o fftwnd_threads.o fftw_threads.o
 
-all:	$(LIBFFTW_THREADS)
+all:	$(LIBFFTW_THREADS) tests
 
 tests: test_threads time_threads
 
 clean:	
 	$(RM) -f *.o core a.out *~ *.s *.bak
 
-realclean: clean
-	$(RM) -f $(LIBFFTW_THREADS) test_threads time_threads
+distclean: clean
+	$(RM) -f $(LIBFFTW_THREADS) test_threads time_threads *.out
 
 %.o:	%.c $(HEADERS)
 	$(CC) $(CFLAGS) -c $< -o $@
@@ -84,9 +88,9 @@
 
 test_threads: test_threads.o $(LIBFFTW_THREADS)
 	$(CC) $(LDFLAGS) test_threads.o \
-              $(LIBS) $(LIBFFTW_THREADS) -o test_threads
+              $(LIBFFTW_THREADS) $(LIBS) -o test_threads
 
 time_threads: time_threads.o $(LIBFFTW_THREADS)
 	$(CC) $(LDFLAGS) time_threads.o \
-              $(LIBS) $(LIBFFTW_THREADS) -o time_threads
+              $(LIBFFTW_THREADS) $(LIBS) -o time_threads

=== mpi/transpose_mpi/Makefile ===
CC = mpicc
CFLAGS = -native -fast -xO5 -dalign -DSOLARIS -I.

all: test_transpose_mpi

test_transpose_mpi: transpose_mpi.o test_transpose_mpi.o TOMS_transpose.o
	$(CC) $(CFLAGS) transpose_mpi.o test_transpose_mpi.o \
                        TOMS_transpose.o -o test_transpose_mpi

clean:
	rm -f *.o core a.out test_transpose_mpi *~

## fftw 2.1.3

=== cilk/Makefile ===
--- 
+++ 
@@ -44,7 +44,7 @@
 CILK_DIR = $(HOME)/sandbox/cilk
 
 # include makefile from distribution directory
-include $(CILK_DIR)/Makefile.common
+-include $(CILK_DIR)/Makefile.common
 
 # set this to a version of gcc that uses the GNU linker:
 CC = gcc
@@ -80,13 +80,13 @@
 	cp $(FFTWDIR)/rader.c rader.cilk
 
 
-%.o:	%.c $(HEADERS) $(CILK_DIR)/Makefile.common Makefile
+%.o:	%.c $(HEADERS)  Makefile
 	$(CC) $(MY_CFLAGS) -c $< -o $@
 
-%.s:	%.c $(HEADERS) $(CILK_DIR)/Makefile.common Makefile
+%.s:	%.c $(HEADERS)  Makefile
 	$(CC) $(MY_CFLAGS) -S $< -o $@
 
-%.c:	%.cilk $(HEADERS) $(CILK2C) $(CILK_DIR)/Makefile.common Makefile
+%.c:	%.cilk $(HEADERS) $(CILK2C)  Makefile
 	$(CILK2C) $(CILK2CFLAGS) -- $(MY_CFLAGS) -- $< -o $@
 
 $(LIBFFTW_CILK): executor_cilk.o fftwnd_cilk.o $(OTHER_FFTW_OBJECTS)

## fftw 2.1.5

=== gensrc/Makefile ===
# Makefile for the generation of FFTW sources/Makefile

install: allfiles
	sh install.sh
	make clean

allfiles: Makefile.fftw sources config.c rconfig.c

config.c:
	sh makeconfig.sh | indent >$@

rconfig.c:
	sh makerconfig.sh | indent >$@

sources:
	sh makesources.sh

gen:
	make -f Makefile.genfft

Makefile.fftw:
	sh makemakefile.sh

distclean: clean

clean:
	rm -f *~ a.out core *.c genfft *.zi *.zo nohup.out 
	rm -f *.cm[xio] *.o
	rm -f Makefile.fftw Makefile.rfftw
	rm -f *.c

=== debian/changelog ===
fftw (2.1.5-6) unstable; urgency=medium

  * Team upload.
  * DEP3
  * Enable architecture all builds
  * Enhance clean target
  * Do not run configure twice (in arch and indep build) to ensure
    libsfftw will be properly build
    Closes: #999821

 -- Andreas Tille <tille@debian.org>  Wed, 19 Jan 2022 16:38:42 +0100

fftw (2.1.5-5) unstable; urgency=medium

  * Team upload

  [ Jelmer Vernooĳ ]
  * Change priority extra to priority optional.

  [ Andreas Tille ]
  * Add watch file
  * Standards-Version: 4.6.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Point Vcs fields to salsa.debian.org (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Trim trailing whitespace.
  * Use secure URI in Homepage field.
  * Remove Section on fftw2, Section on fftw-dev, Section on sfftw2, Section on
    sfftw-dev that duplicate source.
  * Apply multi-arch hints.
    + fftw-docs: Add Multi-Arch: foreign.
  * Machine readable copyright
  * Switch to dh
  * Enable dh_missing --failmissing (as per dh compat 13)
  * Use Debian packaged texi2html
    Closes: #800653

 -- Andreas Tille <tille@debian.org>  Wed, 10 Nov 2021 16:53:14 +0100

fftw (2.1.5-4.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix "FTBFS: Unescaped left brace in regex is deprecated here":
    add patch fix-texi2html-perl526.patch to fix Perl 5.26 regexp
    warnings/errors.
    (Closes: #871367)
  * Add support for DEB_BUILD_OPTIONS=nocheck in debian/rules.

 -- gregor herrmann <gregoa@debian.org>  Wed, 16 Aug 2017 03:22:14 +0200

fftw (2.1.5-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix "FTBFS due to bfnnconv.pl failing to execute m-ascii.pl (.
    removed from @INC in perl)":
    add patch adding "./" to the require() calls in FAQ/bfnnconv.pl.
    (Closes: #837055)

 -- gregor herrmann <gregoa@debian.org>  Sun, 18 Sep 2016 14:15:51 +0200

fftw (2.1.5-4) unstable; urgency=medium

  * Team upload
  * Bug fix: "Removal of debhelper compat 4", thanks to
    niels@thykier.net</a>; (Closes: #817452).

 -- Thibaut Paumard <thibaut@debian.org>  Tue, 12 Jul 2016 09:42:31 +0200

fftw (2.1.5-3) unstable; urgency=medium

  * Team upload.
  * Run wrap-and-sort.
  * Packaging moved to git, set correctly Vcs-Git and Vcs-Browser.
  * remove useless debian/*dirs files.
  * Fix FTBFS with perl 5.22.  Closes: #811223
    Thanks to Graham Inggs <ginggs@debian.org> for the patch!
  * Use DEB_HOST_ARCH_CPU instead of DEB_HOST_ARCH to correctly optimize for
    non-linux architectures too.  Closes: #674762
    Thanks: Robert Millan <rmh@debian.org> for the patch!

 -- Mattia Rizzolo <mattia@debian.org>  Fri, 12 Feb 2016 23:09:00 +0000

fftw (2.1.5-2) unstable; urgency=low

  * Team upload.
  * Bug fix: "FTBFS with TZ=GMT-14", thanks to Holger Levsen (Closes:
    #786694).
  * Fix fftw.texi and make sure it is always rebuilt.
  * Check against Policy 3.9.6

 -- Thibaut Paumard <thibaut@debian.org>  Tue, 23 Jun 2015 11:48:16 +0200

fftw (2.1.5-1) unstable; urgency=low

  * Team upload.
  * New upstream release
  * Package moved into the Debian Science team (no answer from the previous
    maintainer) and package not maintained.
  * Standards-Version updated to version 3.9.2
  * Vcs-Browser & Vcs-Svn updated
  * Switch to mpi-default-dev (Closes: #571446)
  * Get ride of .la files (Closes: #633175)
  * Fix lintian warning debhelper-but-no-misc-depends
  * Fix lintian warning patch-system-but-direct-changes-in-diff
  * Switch to dpkg-source 3.0 (quilt) format

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 29 Nov 2011 01:48:33 +0100

fftw (2.1.3-22) unstable; urgency=low

  * Add missed patches from 2.1.3-20.1 to dpatch (closes: #480908)
  * Call autoreconf to avoid shipping Makefile.inS in diff.gz
  * debian/control: add build-depends on autotools-dev, autoconf and automake
  * debian/control: add build-conflicts on autoconf2.13, automake1.4
  * debian/rules: add build-depends on dpatch
  * debian/rules: use $(CURDIR), not `pwd`
  * debian/rules: do not ignore clean failures
  * debian/control: bump Standards-Version to 3.7.3
  * debian/control: fftw-docs to Section doc
  * debian/control: {,s}fftw-dev use binary:Version, not Source-Version

 -- Paul Brossier <piem@debian.org>  Wed, 14 May 2008 11:23:40 +0200

fftw (2.1.3-21) unstable; urgency=low

  * Acknowledge non-maintainer upload, thanks to Colin Tuckley
    (closes: #466366)
  * Fix bashism in debian/rules, thanks to Chris Lamb and Raphael Geissert
    (closes: #478375)

 -- Paul Brossier <piem@debian.org>  Sat, 10 May 2008 19:46:07 +0200

fftw (2.1.3-20.1) unstable; urgency=low

  * Non-maintainer Upload.
  * Use/depend on gfortran based Lapack and Blas packages (Closes: #466366).
  * Build with gfortran instead of g77.

 -- Colin Tuckley <colint@debian.org>  Mon, 25 Feb 2008 09:37:07 +0000

fftw (2.1.3-20) unstable; urgency=low

  * Add working makefiles to fftw-docs (closes: #378550)

 -- Paul Brossier <piem@debian.org>  Thu,  5 Oct 2006 01:53:10 +0200

fftw (2.1.3-19) unstable; urgency=low

  * Patch tests/test_main.c to workaround buggy counter when using gcc 4.1 on
    64 bit machines (many thanks to Vincent Fourmond, closes: #373647)

 -- Paul Brossier <piem@debian.org>  Sat,  1 Jul 2006 11:53:33 +0200

fftw (2.1.3-18) unstable; urgency=low

  * Fix inclusions in generated headers (closes: #372518)
  * Realign paragraphs in long descriptions
  * Change Priority to extra

 -- Paul Brossier <piem@debian.org>  Sat, 10 Jun 2006 14:32:06 +0200

fftw (2.1.3-17) unstable; urgency=low

  * Adopt package (closes: #263126).
  * Acknowledge NMU (closes: #325813, #333631, #334726)
  * Start again packaging from dh_make templates.
  * Fix autoconf/automake
    + update generated files with autoreconf -f -i (closes: #356966)


=== debian/control ===
Source: fftw
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Paul Brossier <piem@debian.org>,
           Thibaut Paumard <thibaut@debian.org>
Section: oldlibs
Priority: optional
Build-Depends: autoconf,
               automake,
               debhelper-compat (= 13),
               gfortran,
               libtool,
               mpi-default-dev,
               texinfo,
               texi2html
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/science-team/fftw
Vcs-Git: https://salsa.debian.org/science-team/fftw.git
Homepage: https://fftw.org
Rules-Requires-Root: no

Package: fftw2
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: fftw-dev,
          mpi-defaults-bin
Conflicts: fftw2-double
Provides: fftw2-double
Description: library for computing Fast Fourier Transforms
 This library computes Fast Fourier Transforms (FFT) in one or more dimensions.
 It is extremely fast. This package contains the shared library version of the
 fftw libraries in double precision.
 .
 To get the static library and the header files you need to install fftw-dev.
 .
 For documentation and test programs, install fftw-docs

Package: fftw-dev
Architecture: any
Depends: fftw2 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: fftw-double-dev,
           fftw1-dev
Provides: fftw-double-dev
Description: library for computing Fast Fourier Transforms
 This library computes FFTs in one or more dimensions. It is extremely fast.
 This package contains the statically linked library and the header files.

Package: sfftw2
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: mpi-defaults-bin,
          sfftw-dev
Conflicts: fftw2-single
Provides: fftw2-single
Description: library for computing Fast Fourier Transforms
 This library computes Fast Fourier Transforms (FFT) in one or more dimensions.
 It is extremely fast. This package contains the shared library version of the
 fftw libraries in single precision.
 .
 To get the static library and the header files you need to install sfftw-dev.
 .
 For documentation and test programs, install fftw-docs

Package: sfftw-dev
Architecture: any
Depends: sfftw2 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: fftw-single-dev,
           fftw1-dev
Provides: fftw-single-dev
Description: library for computing Fast Fourier Transforms
 This library computes FFTs in one or more dimensions. It is extremely fast.
 This package contains the statically linked library and the header files.

Package: fftw-docs
Architecture: all
Section: doc
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: fftw2
Conflicts: k6fftwgel (<< 1.1-8),
           k7fftwgel (<< 1.2-6),
           p4fftwgel-dev (<< 1.2-5)
Multi-Arch: foreign
Description: documentation for fftw
 This package contains the documentation and test programs for fftw, a Fast
 Fourier Transform library.

=== debian/rules ===
#!/usr/bin/make -f

ARCHITECTURE := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

CONFFLAGS := --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info --enable-shared --enable-mpi --enable-threads

ifeq ($(ARCHITECTURE), i386)
  ARCHCONFFLAGS := --enable-i386-hacks
endif

%:
	dh $@

override_dh_clean:
	dh_clean
	rm -rf debian/tmp-double debian/tmp-single
	if [ -d doc_orig ] ; then rm -rf doc; mv doc_orig doc; fi

override_dh_auto_configure-arch:
	F77=gfortran CFLAGS="$(CFLAGS)" CC=mpicc ./configure $(CONFFLAGS) --enable-float --enable-type-prefix $(ARCHCONFFLAGS)

override_dh_auto_configure-indep:
	if [ -e doc/Makefile ] ; then \
	    echo "No need to run configure" ; \
	else \
	    dh_auto_configure -i ; \
	fi

override_dh_auto_build-arch:
	$(MAKE)
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	#$(MAKE) -C tests check
	./tests/fftw_test  -t -e -v -p 1024 -x 1
	./tests/rfftw_test -t -e -v -p 1024 -x 1
endif
	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp-single
	$(MAKE) clean
	# double precision
	F77=gfortran CFLAGS="$(CFLAGS)" CC=mpicc ./configure $(CONFFLAGS) $(ARCHCONFFLAGS)
	$(MAKE)

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	#$(MAKE) -C tests check
	./tests/fftw_test  -t -e -v -p 1024 -x 1
	./tests/rfftw_test -t -e -v -p 1024 -x 1
endif

override_dh_auto_install-arch:
	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp-double

override_dh_configure-indep:
	# docs
	F77=gfortran CFLAGS="$(CFLAGS)" ./configure $(CONFFLAGS) --enable-float --enable-type-prefix $(ARCHCONFFLAGS)

override_dh_auto_build-indep:
	cp -a doc doc_orig
	rm -f doc/fftw.info
	$(MAKE) -C doc
	$(MAKE) -C doc html
	$(MAKE) -C FAQ

override_dh_install-indep:
	dh_install -p fftw-docs FAQ/fftw-faq.html/*.html usr/share/doc/fftw-docs/FAQ
	dh_install -p fftw-docs doc/*.html usr/share/doc/fftw-docs/html
	dh_install -p fftw-docs doc/*.gif usr/share/doc/fftw-docs/html
	#
	dh_install -p fftw-docs debian/mpi/Makefile mpi/TOMS_transpose.h \
		mpi/fftw_mpi_test.c mpi/rfftw_mpi_test.c mpi/sched.h \
		mpi/test_sched.c mpi/test_transpose_mpi.c \
		usr/share/doc/fftw-docs/examples/mpi
	#
	dh_install -p fftw-docs debian/tests/Makefile fftw/config.h fftw/fftw-int.h usr/share/doc/fftw-docs/examples/tests
	for i in README fftw_test.c rfftw_test.c test_main.c test_main.h; do \
		dh_install -p fftw-docs tests/$$i usr/share/doc/fftw-docs/examples/tests; \
	done
	#
	dh_install -p fftw-docs debian/threads/Makefile usr/share/doc/fftw-docs/examples/threads
	for i in fftw_threads-int.h fftw_threads_test.c rfftw_threads_test.c; do \
		dh_install -p fftw-docs threads/$$i usr/share/doc/fftw-docs/examples/threads; \
	done

override_dh_install-arch:
	mkdir -p $(CURDIR)/debian/tmp-single/usr/share/doc/sfftw-dev/fortran
	mkdir -p $(CURDIR)/debian/tmp-double/usr/share/doc/fftw-dev/fortran
	cp -a fortran/fftw_f77.i $(CURDIR)/debian/tmp-single/usr/share/doc/sfftw-dev/fortran/
	cp -a fortran/fftw_f77.i $(CURDIR)/debian/tmp-double/usr/share/doc/fftw-dev/fortran/
	dh_install --sourcedir=$(CURDIR)/debian/tmp-single -p sfftw2
	dh_install --sourcedir=$(CURDIR)/debian/tmp-single -p sfftw-dev
	dh_install --sourcedir=$(CURDIR)/debian/tmp-double -p fftw2
	dh_install --sourcedir=$(CURDIR)/debian/tmp-double -p fftw-dev

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_missing-indep:
	dh_missing -i --list-missing

override_dh_compress:
	dh_compress -X.c -X.h -XMakefile

=== debian/watch ===
version=4

# circumventing an apparent uscan but that introduces an extra "." or the non-matching (-pl[0-9]+)?)
opts="passive,uversionmangle=s/-pl/p/,uversionmangle=s/.$//" ftp://ftp.fftw.org/pub/fftw/ fftw-(2[\.0-9]+(-pl[0-9]+)?).tar\.gz
